/*-------------------------------------------------------------------------
 *
 *  IniFile.h :
 *    Defines the TIniFile class, based on glib's key-file mechanism
 *
 *  $Id: IniFile.h 419 2007-06-03 14:53:21Z rob $
 --------------------------------------------------------------------------*/

#ifndef __IniFileH__

#include <string>
#include <vector>
#include <glib.h>

class TIniFile
{
public:
    TIniFile ( std::string filename );
//    TIniFile ( char * filename );
    ~TIniFile();

    void ReadSection ( const std::string section, std::vector<std::string> * keys );
    void ReadSections ( std::vector<std::string> * sections );
    bool SectionExists ( const std::string section );
    std::string ReadString ( const std::string section, 
                             const std::string key, 
                             const std::string defval="" );
    bool ReadBool ( const std::string section, 
                    const std::string key, 
                    bool defval=false );
    int ReadInteger ( const std::string section, 
                    const std::string key, 
                    int defval=0 );
    void WriteString ( const std::string section, 
                       const std::string key, 
                       const std::string value );
    void WriteBool ( const std::string section, 
                     const std::string key, 
                     bool value );
    void UpdateFile ( bool force=false );

private:
    GKeyFile * pData;
    std::string FileName;
    bool Dirty;
};

#define __IniFileH__
#endif
